"""
.. module:: teamcontrol.util
   :platform: Unix, Windows
   :synopsis: Utility functions to be used throughout TeamControl

.. moduleauthor:: Caio Romao <caioromao@gmail.com>

"""

__all__ = ["run_command"]

import subprocess
from teamcontrol import ENCODING


def run_command(cmd):
    """Executes a given command a returns it's output.

    :param cmd: command to be executed.
    :rtype: str.
    """
    pipe = subprocess.Popen(cmd, stdout=subprocess.PIPE, shell=True)
    stdout, _ = pipe.communicate()
    # Convert read data to Unicode:
    # * In py3k this goes from byte to str
    # * In py2k it goes from str to unicode
    return stdout.decode(ENCODING).strip()
